﻿
Imports System.Net
Imports System.Runtime.InteropServices
Imports System.IO




Public Class Downloading




    Public Const WM_NCLBUTTONDOWN As Integer = &HA1
    Public Const HT_CAPTION As Integer = &H2

    <DllImportAttribute("user32.dll")> _
    Public Shared Function SendMessage(ByVal hWnd As IntPtr, ByVal Msg As Integer, ByVal wParam As Integer, ByVal lParam As Integer) As Integer
    End Function

    <DllImportAttribute("user32.dll")> _
    Public Shared Function ReleaseCapture() As Boolean
    End Function
    Function GetFileSize(ByVal url As String) As String
        Dim FileSize As Long
        Using obj As New WebClient()
            Using s As Stream = obj.OpenRead(url)
                FileSize = Long.Parse(obj.ResponseHeaders("Content-Length").ToString())
            End Using
        End Using
        Dim CalculatedSize As Decimal
        Dim SizeType As String = "B"

        If FileSize < 1024 Then
            CalculatedSize = FileSize

        ElseIf FileSize > 1024 AndAlso FileSize < (1024 ^ 2) Then 'KB
            CalculatedSize = Math.Round((FileSize / 1024), 2)
            SizeType = "KB"

        ElseIf FileSize > (1024 ^ 2) AndAlso FileSize < (1024 ^ 3) Then 'MB
            CalculatedSize = Math.Round((FileSize / (1024 ^ 2)), 2)
            SizeType = "MB"

        ElseIf FileSize > (1024 ^ 3) AndAlso FileSize < (1024 ^ 4) Then 'GB
            CalculatedSize = Math.Round((FileSize / (1024 ^ 3)), 2)
            SizeType = "GB"

        ElseIf FileSize > (1024 ^ 4) Then 'TB
            CalculatedSize = Math.Round((FileSize / (1024 ^ 4)), 2)
            SizeType = "TB"

        End If
        Dim Result = CalculatedSize.ToString & " " & SizeType

        Return Result
    End Function



    Private Sub Downloading_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        BackgroundWorker1.RunWorkerAsync()
        Dim downloadpath As String = Application.StartupPath() + "\Downloads"
        If (Not System.IO.Directory.Exists(downloadpath)) Then
            System.IO.Directory.CreateDirectory(downloadpath)
        End If
        Dim working_area As Rectangle = _
        SystemInformation.WorkingArea
        Dim x As Integer = _
        working_area.Left + _
        working_area.Width - _
        Me.Width
        Dim y As Integer = _
        working_area.Top + _
        working_area.Height - _
        Me.Height
        y = y - winposition
        Me.Location = New Point(x, y)
        winposition = winposition + 60
        Label1.Text = "Downloading " + seltectname + ":"
        Dim client As WebClient = New WebClient
        AddHandler client.DownloadProgressChanged, AddressOf client_ProgressChanged
        AddHandler client.DownloadFileCompleted, AddressOf client_DownloadCompleted

        client.DownloadFileAsync(New Uri(seltecturl), downloadpath + "\" + seltecturl.Replace("https://www.lastos.org/repo/", "")) ' + ".tempo")

    End Sub

    Private Sub client_ProgressChanged(ByVal sender As Object, ByVal e As DownloadProgressChangedEventArgs)
        Dim bytesIn As Double = Double.Parse(e.BytesReceived.ToString())
        Dim totalBytes As Double = Double.Parse(e.TotalBytesToReceive.ToString())
        Dim percentage As Double = bytesIn / totalBytes * 100

        ProgressBar1.Value = Int32.Parse(Math.Truncate(percentage).ToString())
    End Sub

    Private Sub client_DownloadCompleted(ByVal sender As Object, ByVal e As System.ComponentModel.AsyncCompletedEventArgs)
        winposition = 0
        Close()
    End Sub
    Private Sub frmProgramma_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        winposition = 0
    End Sub

    Private Sub Downloading_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles MyBase.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ReleaseCapture()
            SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0)
        End If
    End Sub

    Private Sub Label2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Label2.Click
        Me.Close()

    End Sub

    Private Sub BackgroundWorker1_DoWork(ByVal sender As System.Object, ByVal e As System.ComponentModel.DoWorkEventArgs) Handles BackgroundWorker1.DoWork
        Label3.Text = GetFileSize(seltecturl)
    End Sub

    Private Sub Label1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles Label1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ReleaseCapture()
            SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0)
        End If
    End Sub

    Private Sub ProgressBar1_MouseDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles ProgressBar1.MouseDown
        If e.Button = Windows.Forms.MouseButtons.Left Then
            ReleaseCapture()
            SendMessage(Handle, WM_NCLBUTTONDOWN, HT_CAPTION, 0)
        End If
    End Sub
End Class

